## rules

# NOTE: while these rules aim to be idempotent, make sure you understand
# what each one is doing before using in your job. you cannot combine rules
# with each other.

.rule:branch:main:
  # the job will only run if the current branch is `master`
  rules:
    - if: '$CI_COMMIT_BRANCH == "main"'
      when: on_success

.rule:branch:dev:
  # the job will only run if the current branch is `master`
  rules:
    - if: '$CI_COMMIT_BRANCH == "dev"'
      when: on_success

.rule:branch:default:
  # the job will only run if the current branch is the configured default branch
  rules:
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
      when: on_success

.rule:pr:
  # the job will only run if a PR (merge request) was created
  rules:
    - if: "$CI_MERGE_REQUEST_ID"
      when: on_success

.rule:format:
  rules:
    - if: '$STAGE == "format"'
      when: on_success

.rule:push:changes:
  # the job will run if there was a `push` event and the previous commit is not
  # an empty commit. the empty commit usually means this branch is newly pushed.
  #
  # this rule is very basic; if you need to watch for changes in other paths,
  # copy this rule into your job and make modifications.
  #
  # to use this rule, ensure you have defined the following variables:
  #   variables:
  #     PROJECT_PATH: "path/to/project"
  rules:
    - if: '$CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_BEFORE_SHA != $EMPTY_BASE_SHA'
      changes:
        - $PROJECT_PATH/**/*
      when: on_success
    - if: '$STAGE == "test"'
      changes:
        - $PROJECT_PATH/**/*
      when: on_success

# THIS IS COMMENTED OUT BECAUSE gitlab-ci DOES NOT "UNDERSTAND" VARIABLES IN
# REGULAR EXPRESSIONS. IF SOME DAY IT DOES, THIS RULE CAN REPLACE THE EXPLICIT
# DEPLOY RULES FOR MOST PROJECTS
# .rule:deploy:stage:
#   # 1. job can only be triggered via a trigger-token (a deliberate action).
#   # 2. ...
#   rules:
#     - if: '$CI_PIPELINE_SOURCE == "trigger" && $STAGE == "deploy" && $SERVICE_ENV == "stage" && $SERVICES =~ /\b$PROJECT_NAME\b/'
#       when: on_success
.rule:push:changes-lib-python:
  # the job will run if there was a `push` event and the previous commit is not
  # an empty commit. the empty commit usually means this branch is newly pushed.
  #
  # this rule includes python changes in lib/python3/leap
  #
  # to use this rule, ensure you have defined the following variables:
  #   variables:
  #     PROJECT_PATH: "path/to/project"
  rules:
    - if: '$CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_BEFORE_SHA != $EMPTY_BASE_SHA'
      changes:
        - lib/python3/leap/**/* # any changes to pyleap
        - $PROJECT_PATH/**/*
      when: on_success
    - if: '$STAGE == "test"'
      changes:
        - lib/python3/leap/**/* # any changes to pyleap
        - $PROJECT_PATH/**/*
      when: on_success
